unit hiMatrix;

interface

uses Windows,Kol,Share,Debug;

type
  THIMatrix = class(TDebug)
   private
    MatrI:array of array of integer;
    MatrR:array of array of real;
    MatrS:array of array of string;        
    Col,Row:integer;
    Obj:TMatrix;
    MatrixType:byte;
    procedure SetRows(Value:integer);
    procedure _Set(x,y:integer; var Val:TData);
    function _Get(x,y:integer):TData;
    function _R:integer;
    function _C:integer;
   public

    _data_Size :THI_Event;
    constructor Create;
    procedure _work_doSize(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _var_Matrix(var _Data:TData; Index:word);
    procedure _var_CountCol(var _Data:TData; Index:word);
    procedure _var_CountRow(var _Data:TData; Index:word);    
    property _prop_Row:integer write SetRows;
    property _prop_Col:integer write Col;
    property _prop_MatrixType:byte write MatrixType;
  end;

implementation

constructor THIMatrix.Create;
begin
   inherited;
   Obj._Set := _Set;
   Obj._Get := _Get;
   Obj._Rows := _R;
   Obj._Cols := _C;
end;

procedure THIMatrix._Set;
begin
   if (x >=0) and (y >=0) and (x < Col) and (y < Row) then
      case MatrixType of
         0: MatrI[y,x] := ToInteger(Val);
         1: MatrR[y,x] := ToReal(Val);
         2: MatrS[y,x] := ToString(Val);
      end;   
end;

function THIMatrix._C;
begin
  Result := Col;
end;

function THIMatrix._R;
begin
  Result := Row;
end;

function THIMatrix._Get;
begin
   if (x >=0) and (y >=0) and (x < Col) and (y < Row) then
      case MatrixType of
         0: dtInteger(Result,MatrI[y,x]);
         1: dtReal(Result,MatrR[y,x]);
         2: dtString(Result,MatrS[y,x]);
      end   
   else dtNull(Result);
end;

procedure THIMatrix._work_doSize;
var   val:cardinal;
begin
   val := ReadInteger(_Data,_data_Size);
   Col := val and $FFFF;
   SetRows(Val shr 16);
end;

procedure THIMatrix._work_doClear;
begin
   case MatrixType of
      0: SetLength(MatrI,0);
      1: SetLength(MatrR,0);
      2: SetLength(MatrS,0);
   end;   
   SetRows(Row);
end;

procedure THIMatrix._var_Matrix;
begin
   dtMatrix(_Data,@Obj);
end;

procedure THIMatrix.SetRows;
var i:integer;
begin
   Row := Value;
   case MatrixType of
      0: begin 
            SetLength(MatrI,Row);
            for i := 0 to Row-1 do SetLength(MatrI[i],Col);
         end;
      1: begin 
            SetLength(MatrR,Row);
            for i := 0 to Row-1 do SetLength(MatrR[i],Col);
         end;
      2: begin 
            SetLength(MatrS,Row);
            for i := 0 to Row-1 do SetLength(MatrS[i],Col);
         end;
   end;      
end;

procedure THIMatrix._var_CountCol;
begin
   dtInteger(_Data, Col);
end;

procedure THIMatrix._var_CountRow;
begin
   dtInteger(_Data, Row);
end;

end.